import { createRoute, OpenAPIHono, z } from "@hono/zod-openapi";
import { responses } from "../../../globalUtils/routeDefs/responses.js";
import { tryCatch } from "../../../globalUtils/tryCatch.js";
import { getINV } from "../controller/getinventory.js";
import { apiHit } from "../../../globalUtils/apiHits.js";

const app = new OpenAPIHono({ strict: false });
const Body = z.object({
    includeRunnningNumbers: z.string().openapi({ example: "x" }),
});
app.openapi(
    createRoute({
        tags: ["dataMart"],
        summary: "Returns All current inventory.",
        method: "get",
        path: "/getinventory",
        request: {
            body: {
                content: {
                    "application/json": { schema: Body },
                },
            },
        },
        responses: responses(),
    }),
    async (c) => {
        const includeRunnningNumbers: string =
            c.req.query("includeRunnningNumbers") ?? "";

        // make sure we have a vaid user being accessed thats really logged in
        apiHit(c, { endpoint: "/getinventory" });
        const { data, error } = await tryCatch(
            getINV(includeRunnningNumbers?.length > 0 ? true : false)
        );

        if (error) {
            return c.json(
                {
                    success: false,
                    message: "There was an error getting the inv.",
                    data: error,
                },
                400
            );
        }

        return c.json({
            success: data.success,
            message: data.message,
            data: data.data,
        });
    }
);
export default app;
